setwd ("D:/PCRData/R-scripts/Spatial_Averaging_Velocity_Data_For_Grid/April2013/Centroid")
GPS_File <- read.table(file='April2013_Raw_Centroid.txt', check.names=F, sep=',', header=T, 
                      stringsAsFactors=F)
library(plyr)
library(ggplot2)
GPS_File$Relative_Depth <- GPS_File$Elev_m_1/GPS_File$Elev_m  #Creates a Relative Depth column

GPS_File$Dis_From_Center <- sqrt((GPS_File$Cent_X-GPS_File$Easting_m)^2 + (GPS_File$Cent_Y-GPS_File$Northing_m)^2) #distance from center of grid

#Velocities at relative depths
Depth_.0625 <- subset(GPS_File, Relative_Depth > 0)
Depth_.0625 <- subset(Depth_.0625, Relative_Depth <= .125)
Depth_.1875 <- subset(GPS_File, Relative_Depth > .125)
Depth_.1875 <- subset(Depth_.1875, Relative_Depth <= .25)
Depth_.3125 <- subset(GPS_File, Relative_Depth > .25)
Depth_.3125 <- subset(Depth_.3125, Relative_Depth <= .375)
Depth_.4375 <- subset(GPS_File, Relative_Depth > .375)
Depth_.4375 <- subset(Depth_.4375, Relative_Depth <= .5)
Depth_.5625 <- subset(GPS_File, Relative_Depth > .5)
Depth_.5625 <- subset(Depth_.5625, Relative_Depth <= .625)
Depth_.6875 <- subset(GPS_File, Relative_Depth > .625)
Depth_.6875 <- subset(Depth_.6875, Relative_Depth <= .75)
Depth_.8125 <- subset(GPS_File, Relative_Depth > .75)
Depth_.8125 <- subset(Depth_.8125, Relative_Depth <= .875)
Depth_.9375 <- subset(GPS_File, Relative_Depth > .875)
Depth_.9375 <- subset(Depth_.9375, Relative_Depth <= 1)

Depth_.6 <- subset(GPS_File, Relative_Depth > .55)
Depth_.6 <- subset(Depth_.6, Relative_Depth < .65)

Depth_.0625mean <- aggregate(Depth_.0625, by=list(Depth_.0625$I_J), FUN=mean)
Depth_.0625max  <- aggregate(Depth_.0625, by=list(Depth_.0625$I_J), FUN=max)
Depth_.0625min  <- aggregate(Depth_.0625, by=list(Depth_.0625$I_J), FUN=min)
Depth_.0625count  <- aggregate(Depth_.0625, by=list(Depth_.0625$I_J), FUN=length)

Depth_.1875mean <- aggregate(Depth_.1875, by=list(Depth_.1875$I_J), FUN=mean)
Depth_.1875max  <- aggregate(Depth_.1875, by=list(Depth_.1875$I_J), FUN=max)
Depth_.1875min  <- aggregate(Depth_.1875, by=list(Depth_.1875$I_J), FUN=min)
Depth_.1875count  <- aggregate(Depth_.1875, by=list(Depth_.1875$I_J), FUN=length)

Depth_.3125mean <- aggregate(Depth_.3125, by=list(Depth_.3125$I_J), FUN=mean)
Depth_.3125max  <- aggregate(Depth_.3125, by=list(Depth_.3125$I_J), FUN=max)
Depth_.3125min  <- aggregate(Depth_.3125, by=list(Depth_.3125$I_J), FUN=min)
Depth_.3125count  <- aggregate(Depth_.3125, by=list(Depth_.3125$I_J), FUN=length)

Depth_.4375mean <- aggregate(Depth_.4375, by=list(Depth_.4375$I_J), FUN=mean)
Depth_.4375max  <- aggregate(Depth_.4375, by=list(Depth_.4375$I_J), FUN=max)
Depth_.4375min  <- aggregate(Depth_.4375, by=list(Depth_.4375$I_J), FUN=min)
Depth_.4375count  <- aggregate(Depth_.4375, by=list(Depth_.4375$I_J), FUN=length)

Depth_.5625mean <- aggregate(Depth_.5625, by=list(Depth_.5625$I_J), FUN=mean)
Depth_.5625max  <- aggregate(Depth_.5625, by=list(Depth_.5625$I_J), FUN=max)
Depth_.5625min  <- aggregate(Depth_.5625, by=list(Depth_.5625$I_J), FUN=min)
Depth_.5625count  <- aggregate(Depth_.5625, by=list(Depth_.5625$I_J), FUN=length)

Depth_.6875mean <- aggregate(Depth_.6875, by=list(Depth_.6875$I_J), FUN=mean)
Depth_.6875max  <- aggregate(Depth_.6875, by=list(Depth_.6875$I_J), FUN=max)
Depth_.6875min  <- aggregate(Depth_.6875, by=list(Depth_.6875$I_J), FUN=min)
Depth_.6875count  <- aggregate(Depth_.6875, by=list(Depth_.6875$I_J), FUN=length)

Depth_.8125mean <- aggregate(Depth_.8125, by=list(Depth_.8125$I_J), FUN=mean)
Depth_.8125max  <- aggregate(Depth_.8125, by=list(Depth_.8125$I_J), FUN=max)
Depth_.8125min  <- aggregate(Depth_.8125, by=list(Depth_.8125$I_J), FUN=min)
Depth_.8125count  <- aggregate(Depth_.8125, by=list(Depth_.8125$I_J), FUN=length)

Depth_.9375mean <- aggregate(Depth_.9375, by=list(Depth_.9375$I_J), FUN=mean)
Depth_.9375max  <- aggregate(Depth_.9375, by=list(Depth_.9375$I_J), FUN=max)
Depth_.9375min  <- aggregate(Depth_.9375, by=list(Depth_.9375$I_J), FUN=min)
Depth_.9375count  <- aggregate(Depth_.9375, by=list(Depth_.9375$I_J), FUN=length)

Depth_.6mean <- aggregate(Depth_.6, by=list(Depth_.6$I_J), FUN=mean)
Depth_.6max  <- aggregate(Depth_.6, by=list(Depth_.6$I_J), FUN=max)
Depth_.6min  <- aggregate(Depth_.6, by=list(Depth_.6$I_J), FUN=min)
Depth_.6count  <- aggregate(Depth_.6, by=list(Depth_.6$I_J), FUN=length)

Depth_.0625 <- merge(Depth_.0625mean,Depth_.0625max,by.x=("Group.1"),by.y=("Group.1"),
                  suffixes= c(".0625MEAN",".0625MAX"))
Depth_.06251 <- merge(Depth_.0625min,Depth_.0625count,by.x=("Group.1"),by.y=("Group.1"),
                   suffixes= c(".0625MIN",".0625CT"))
Depth_.0625 <- merge(Depth_.0625,Depth_.06251,by.x=("Group.1"),by.y=("Group.1"))

Depth_.1875 <- merge(Depth_.1875mean,Depth_.1875max,by.x=("Group.1"),by.y=("Group.1"),
                  suffixes= c(".1875MEAN",".1875MAX"))
Depth_.18751 <- merge(Depth_.1875min,Depth_.1875count,by.x=("Group.1"),by.y=("Group.1"),
                   suffixes= c(".1875MIN",".1875CT"))
Depth_.1875 <- merge(Depth_.1875,Depth_.18751,by.x=("Group.1"),by.y=("Group.1"))

Depth_.3125 <- merge(Depth_.3125mean,Depth_.3125max,by.x=("Group.1"),by.y=("Group.1"),
                  suffixes= c(".3125MEAN",".3125MAX"))
Depth_.31251 <- merge(Depth_.3125min,Depth_.3125count,by.x=("Group.1"),by.y=("Group.1"),
                   suffixes= c(".3125MIN",".3125CT"))
Depth_.3125 <- merge(Depth_.3125,Depth_.31251,by.x=("Group.1"),by.y=("Group.1"))

Depth_.4375 <- merge(Depth_.4375mean,Depth_.4375max,by.x=("Group.1"),by.y=("Group.1"),
                  suffixes= c(".4375MEAN",".4375MAX"))
Depth_.43751 <- merge(Depth_.4375min,Depth_.4375count,by.x=("Group.1"),by.y=("Group.1"),
                   suffixes= c(".4375MIN",".4375CT"))
Depth_.4375 <- merge(Depth_.4375,Depth_.43751,by.x=("Group.1"),by.y=("Group.1"))

Depth_.5625 <- merge(Depth_.5625mean,Depth_.5625max,by.x=("Group.1"),by.y=("Group.1"),
                  suffixes= c(".5625MEAN",".5625MAX"))
Depth_.56251 <- merge(Depth_.5625min,Depth_.5625count,by.x=("Group.1"),by.y=("Group.1"),
                   suffixes= c(".5625MIN",".5625CT"))
Depth_.5625 <- merge(Depth_.5625,Depth_.56251,by.x=("Group.1"),by.y=("Group.1"))

Depth_.6875 <- merge(Depth_.6875mean,Depth_.6875max,by.x=("Group.1"),by.y=("Group.1"),
                  suffixes= c(".6875MEAN",".6875MAX"))
Depth_.68751 <- merge(Depth_.6875min,Depth_.6875count,by.x=("Group.1"),by.y=("Group.1"),
                   suffixes= c(".6875MIN",".6875CT"))
Depth_.6875 <- merge(Depth_.6875,Depth_.68751,by.x=("Group.1"),by.y=("Group.1"))

Depth_.8125 <- merge(Depth_.8125mean,Depth_.8125max,by.x=("Group.1"),by.y=("Group.1"),
                  suffixes= c(".8125MEAN",".8125MAX"))
Depth_.81251 <- merge(Depth_.8125min,Depth_.8125count,by.x=("Group.1"),by.y=("Group.1"),
                   suffixes= c(".8125MIN",".8125CT"))
Depth_.8125 <- merge(Depth_.8125,Depth_.81251,by.x=("Group.1"),by.y=("Group.1"))

Depth_.9375 <- merge(Depth_.9375mean,Depth_.9375max,by.x=("Group.1"),by.y=("Group.1"),
                  suffixes= c(".9375MEAN",".9375MAX"))
Depth_.93751 <- merge(Depth_.9375min,Depth_.9375count,by.x=("Group.1"),by.y=("Group.1"),
                   suffixes= c(".9375MIN",".9375CT"))
Depth_.9375 <- merge(Depth_.9375,Depth_.93751,by.x=("Group.1"),by.y=("Group.1"))

Depth_.6 <- merge(Depth_.6mean,Depth_.6max,by.x=("Group.1"),by.y=("Group.1"),
                     suffixes= c(".6MEAN",".6MAX"))
Depth_.61 <- merge(Depth_.6min,Depth_.6count,by.x=("Group.1"),by.y=("Group.1"),
                      suffixes= c(".6MIN",".6CT"))
Depth_.6 <- merge(Depth_.6,Depth_.61,by.x=("Group.1"),by.y=("Group.1"))

############################add bin labels in order to graph the profile############################################
Depth_.0625$V_Bin <- .0625
Depth_.1875$V_Bin <- .1875
Depth_.3125$V_Bin <- .3125
Depth_.4375$V_Bin <- .4375
Depth_.5625$V_Bin <- .5625
Depth_.6875$V_Bin <- .6875
Depth_.8125$V_Bin <- .8125
Depth_.9375$V_Bin <- .9375

Averaged_Cell_Data_mean <- aggregate(GPS_File, by=list(GPS_File$I_J), FUN=mean)
Averaged_Cell_Data_max <- aggregate(GPS_File, by=list(GPS_File$I_J), FUN=max)
Averaged_Cell_Data_min <- aggregate(GPS_File, by=list(GPS_File$I_J), FUN=min)
Averaged_Cell_Data_count <- aggregate(GPS_File, by=list(GPS_File$I_J), FUN=length)

#####################################AVERAGED ENSEMBLE DATA###########################
Averaged_Cell_Headers <- c("Group.1","Easting_m","Northing_m","Cent_X","Cent_Y","u_cm_s","v_cm_s","w_cm_s",
                           "Depth_m","Dis_From_Center")
Averaged_Cell_Data <- Averaged_Cell_Data_mean[Averaged_Cell_Headers]

names(Averaged_Cell_Data) <- c("I_J_AVG","UTM_X","UTM_Y","Cent_X","Cent_Y","MEAN_u_cm_s","MEAN_v_cm_s","MEAN_w_cm_s",
                               "MEAN_depth_m","MEAN_dis_from_center")

Averaged_Cell_Data$MAX_u_cm_s <- Averaged_Cell_Data_max$u_cm_s
Averaged_Cell_Data$MAX_v_cm_s <- Averaged_Cell_Data_max$v_cm_s
Averaged_Cell_Data$MAX_w_cm_s <- Averaged_Cell_Data_max$w_cm_s
Averaged_Cell_Data$MAX_Depth_m   <- Averaged_Cell_Data_max$Depth_m
Averaged_Cell_Data$MAX_hmag_cm_s   <- Averaged_Cell_Data_max$hmag_cm_s
Averaged_Cell_Data$MAX_dis_from_center <- Averaged_Cell_Data_max$Dis_From_Center

Averaged_Cell_Data$MIN_u_cm_s <- Averaged_Cell_Data_min$u_cm_s
Averaged_Cell_Data$MIN_v_cm_s <- Averaged_Cell_Data_min$v_cm_s
Averaged_Cell_Data$MIN_w_cm_s <- Averaged_Cell_Data_min$w_cm_s
Averaged_Cell_Data$MIN_Depth_m   <- Averaged_Cell_Data_min$Depth_m 
Averaged_Cell_Data$MIN_hmag_cm_s   <- Averaged_Cell_Data_min$hmag_cm_s
Averaged_Cell_Data$MIN_dis_from_center <- Averaged_Cell_Data_max$Dis_From_Center

Averaged_Cell_Data$CT <- Averaged_Cell_Data_count$u_cm_s

#####################################################################################

All_Data <- merge(Averaged_Cell_Data,Depth_.0625,by.x=("I_J_AVG"),by.y=("Group.1"),
                  ,all=TRUE)
All_Data <- merge(All_Data,Depth_.1875,by.x=("I_J_AVG"),by.y=("Group.1"),
                  ,all=TRUE)
All_Data <- merge(All_Data,Depth_.3125,by.x=("I_J_AVG"),by.y=("Group.1"),
                  ,all=TRUE)
All_Data <- merge(All_Data,Depth_.4375,by.x=("I_J_AVG"),by.y=("Group.1"),
                  ,all=TRUE)
All_Data <- merge(All_Data,Depth_.5625,by.x=("I_J_AVG"),by.y=("Group.1"),
                  ,all=TRUE)
All_Data <- merge(All_Data,Depth_.6875,by.x=("I_J_AVG"),by.y=("Group.1"),
                  ,all=TRUE)
All_Data <- merge(All_Data,Depth_.8125,by.x=("I_J_AVG"),by.y=("Group.1"),
                  ,all=TRUE)
All_Data <- merge(All_Data,Depth_.9375,by.x=("I_J_AVG"),by.y=("Group.1"),
                  ,all=TRUE)
All_Data <- merge(All_Data,Depth_.6,by.x=("I_J_AVG"),by.y=("Group.1"),
                  ,all=TRUE)
###########################################################################
All_Data_Headers <- c("I_J_AVG","UTM_X","UTM_Y","Cent_X","Cent_Y","MEAN_u_cm_s","MEAN_v_cm_s","MEAN_w_cm_s",
                      "MEAN_depth_m","MAX_Depth_m","MIN_Depth_m","MEAN_dis_from_center",
                      "MAX_u_cm_s","MAX_v_cm_s","MAX_w_cm_s",
                      "MIN_u_cm_s","MIN_v_cm_s","MIN_w_cm_s",
                      "MAX_hmag_cm_s","MIN_hmag_cm_s", 
                      "CT",
                      "u_cm_s.0625MEAN","v_cm_s.0625MEAN","w_cm_s.0625MEAN",
                      "u_cm_s.0625MAX","v_cm_s.0625MAX","w_cm_s.0625MAX",
                      "u_cm_s.0625MIN","v_cm_s.0625MIN","w_cm_s.0625MIN",
                      "hmag_cm_s.0625MAX","hmag_cm_s.0625MIN",
                      "u_cm_s.0625CT",
                      "u_cm_s.1875MEAN","v_cm_s.1875MEAN","w_cm_s.1875MEAN",
                      "u_cm_s.1875MAX","v_cm_s.1875MAX","w_cm_s.1875MAX",
                      "u_cm_s.1875MIN","v_cm_s.1875MIN","w_cm_s.1875MIN",
                      "hmag_cm_s.1875MAX","hmag_cm_s.1875MIN",
                      "u_cm_s.1875CT",
                      "u_cm_s.3125MEAN","v_cm_s.3125MEAN","w_cm_s.3125MEAN",
                      "u_cm_s.3125MAX","v_cm_s.3125MAX","w_cm_s.3125MAX",
                      "u_cm_s.3125MIN","v_cm_s.3125MIN","w_cm_s.3125MIN",
                      "hmag_cm_s.3125MAX","hmag_cm_s.3125MIN",
                      "u_cm_s.3125CT",
                      "u_cm_s.4375MEAN","v_cm_s.4375MEAN","w_cm_s.4375MEAN",
                      "u_cm_s.4375MAX","v_cm_s.4375MAX","w_cm_s.4375MAX",
                      "u_cm_s.4375MIN","v_cm_s.4375MIN","w_cm_s.4375MIN",
                      "hmag_cm_s.4375MAX","hmag_cm_s.4375MIN",
                      "u_cm_s.4375CT",
                      "u_cm_s.5625MEAN","v_cm_s.5625MEAN","w_cm_s.5625MEAN",
                      "u_cm_s.5625MAX","v_cm_s.5625MAX","w_cm_s.5625MAX",
                      "u_cm_s.5625MIN","v_cm_s.5625MIN","w_cm_s.5625MIN",
                      "hmag_cm_s.5625MAX","hmag_cm_s.5625MIN",
                      "u_cm_s.5625CT",
                      "u_cm_s.6875MEAN","v_cm_s.6875MEAN","w_cm_s.6875MEAN",
                      "u_cm_s.6875MAX","v_cm_s.6875MAX","w_cm_s.6875MAX",
                      "u_cm_s.6875MIN","v_cm_s.6875MIN","w_cm_s.6875MIN",
                      "hmag_cm_s.6875MAX","hmag_cm_s.6875MIN",
                      "u_cm_s.6875CT",
                      "u_cm_s.8125MEAN","v_cm_s.8125MEAN","w_cm_s.8125MEAN",
                      "u_cm_s.8125MAX","v_cm_s.8125MAX","w_cm_s.8125MAX",
                      "u_cm_s.8125MIN","v_cm_s.8125MIN","w_cm_s.8125MIN",
                      "hmag_cm_s.8125MAX","hmag_cm_s.8125MIN",
                      "u_cm_s.8125CT",
                      "u_cm_s.9375MEAN","v_cm_s.9375MEAN","w_cm_s.9375MEAN",
                      "u_cm_s.9375MAX","v_cm_s.9375MAX","w_cm_s.9375MAX",
                      "u_cm_s.9375MIN","v_cm_s.9375MIN","w_cm_s.9375MIN",
                      "hmag_cm_s.9375MAX","hmag_cm_s.9375MIN",
                      "u_cm_s.9375CT",
                      "u_cm_s.6MEAN","v_cm_s.6MEAN","w_cm_s.6MEAN",
                      "u_cm_s.6MAX","v_cm_s.6MAX","w_cm_s.6MAX",
                      "u_cm_s.6MIN","v_cm_s.6MIN","w_cm_s.6MIN",
                      "hmag_cm_s.6MAX","hmag_cm_s.6MIN",
                      "u_cm_s.6CT")
All_Data2 <- All_Data[All_Data_Headers]

#Calculates AVERAGE CELL IN VERTICAL the True Velocity Magnatude
All_Data2["MEAN_Mag"] <- sqrt((All_Data$MEAN_u_cm_s^2)+(All_Data$MEAN_v_cm_s^2))
All_Data2["MEAN_Dir"] <- (90-atan2(All_Data$MEAN_v_cm_s,All_Data$MEAN_u_cm_s)*180/pi)%%(360)

#Calculates AVERAGE CELL Iat realative depths the True Velocity Magnatude
All_Data2[".0625MEAN_Mag"] <- sqrt((All_Data$u_cm_s.0625MEAN^2)+(All_Data$v_cm_s.0625MEAN^2))
All_Data2[".0625MEAN_Dir"] <- (90-atan2(All_Data$v_cm_s.0625MEAN,All_Data$u_cm_s.0625MEAN)*180/pi)%%(360)


All_Data2[".1875MEAN_Mag"] <- sqrt((All_Data$u_cm_s.1875MEAN^2)+(All_Data$v_cm_s.1875MEAN^2))
All_Data2[".1875MEAN_Dir"] <- (90-atan2(All_Data$v_cm_s.1875MEAN,All_Data$u_cm_s.1875MEAN)*180/pi)%%(360)


All_Data2[".3125MEAN_Mag"] <- sqrt((All_Data$u_cm_s.3125MEAN^2)+(All_Data$v_cm_s.3125MEAN^2))
All_Data2[".3125MEAN_Dir"] <- (90-atan2(All_Data$v_cm_s.3125MEAN,All_Data$u_cm_s.3125MEAN)*180/pi)%%(360)


All_Data2[".4375MEAN_Mag"] <- sqrt((All_Data$u_cm_s.4375MEAN^2)+(All_Data$v_cm_s.4375MEAN^2))
All_Data2[".4375MEAN_Dir"] <- (90-atan2(All_Data$v_cm_s.4375MEAN,All_Data$u_cm_s.4375MEAN)*180/pi)%%(360)


All_Data2[".5625MEAN_Mag"] <- sqrt((All_Data$u_cm_s.5625MEAN^2)+(All_Data$v_cm_s.5625MEAN^2))
All_Data2[".5625MEAN_Dir"] <- (90-atan2(All_Data$v_cm_s.5625MEAN,All_Data$u_cm_s.5625MEAN)*180/pi)%%(360)


All_Data2[".6875MEAN_Mag"] <- sqrt((All_Data$u_cm_s.6875MEAN^2)+(All_Data$v_cm_s.6875MEAN^2))
All_Data2[".6875MEAN_Dir"] <- (90-atan2(All_Data$v_cm_s.6875MEAN,All_Data$u_cm_s.6875MEAN)*180/pi)%%(360)


All_Data2[".8125MEAN_Mag"] <- sqrt((All_Data$u_cm_s.8125MEAN^2)+(All_Data$v_cm_s.8125MEAN^2))
All_Data2[".8125MEAN_Dir"] <- (90-atan2(All_Data$v_cm_s.8125MEAN,All_Data$u_cm_s.8125MEAN)*180/pi)%%(360)


All_Data2[".9375MEAN_Mag"] <- sqrt((All_Data$u_cm_s.9375MEAN^2)+(All_Data$v_cm_s.9375MEAN^2))
All_Data2[".9375MEAN_Dir"] <- (90-atan2(All_Data$v_cm_s.9375MEAN,All_Data$u_cm_s.9375MEAN)*180/pi)%%(360)


All_Data2[".6MEAN_Mag"] <- sqrt((All_Data$u_cm_s.6MEAN^2)+(All_Data$v_cm_s.6MEAN^2))
All_Data2[".6MEAN_Dir"] <- (90-atan2(All_Data$v_cm_s.6MEAN,All_Data$u_cm_s.6MEAN)*180/pi)%%(360)

########################################################Determines how much of the time the flow is going right left upstream or downstream##########################

Direction <- cbind(GPS_File$I_J,GPS_File$hdir_deg_,GPS_File$hmag_cm_s)

Mean_Direction <- cbind(All_Data2$I_J_AVG,All_Data2$MEAN_Dir)

Direction <- merge(Direction,Mean_Direction,by.x=("V1"),by.y=("V1"))

Direction$V2.x <- as.character(Direction$V2.x)
Direction$V2.x <- as.numeric(Direction$V2.x)
Direction$V2.y <- as.character(Direction$V2.y)
Direction$V2.y <- as.numeric(Direction$V2.y)
Direction$V3 <- as.character(Direction$V3)
Direction$V3 <- as.numeric(Direction$V3)
Direction$V1 <- as.character(Direction$V1)


Direction$Diff <- (Direction$V2.x - Direction$V2.y)%%360

Direction$Right <- ifelse(Direction$Diff >= 45 & Direction$Diff <=135 ,1,0)
Direction$UpStream <- ifelse(Direction$Diff >= 135 & Direction$Diff <=225 ,1,0)
Direction$Left <- ifelse(Direction$Diff >= 225 & Direction$Diff <=315 ,1,0)
Direction$DownStream <- ifelse(Direction$Diff >= 315 | Direction$Diff <=45 ,1,0)


Direction_Sum <- ddply(Direction,"V1",summarize,Right=sum(Right),UpStream=sum(UpStream),Left=sum(Left),DownStream=
                         sum(DownStream))

#Direction_Sum <- aggregate(Direction, by=list(Direction$V1), FUN=sum)

Direction$DirCat <- cut(Direction$Diff, breaks = c(0,22.5, 67.5, 112.5, 157.5, 202.5, 247.5, 292.5, 337.5,360),
                                                      labels = c("0", "45", "90", "135", "180","225","270","315","0"))
Direction$SpdCat <- cut(Direction$V3, breaks = c(0,20, 40, 60, 80, 100, 120, 140, 202),
                        labels = c("0-20", "20-40", "40-60", "60-80", "80-100","100-120","120-140","140-200"))
##################################################create windrose graphs of the velocity data#######################################################################
Cell_ID <- unique(Direction$V1)

doPlot = function(Cell_ID) {
  dum <- Direction[Direction$V1 == Cell_ID,]
  ggobj = ggplot(dum,aes(x=DirCat,fill=SpdCat))+
    geom_histogram(binwidth=45,orgin=-22.5,colour="black",size=.25)+
    coord_polar(start=-22.5 * pi/180)+
    scale_fill_brewer() + 
    labs(fill="cm/s")
  print(ggobj)
  ggsave(sprintf("%s.pdf", Cell_ID))

}
lapply(unique(Direction$V1), doPlot)



All_Data3 <- merge(All_Data2,Direction_Sum,by.x=("I_J_AVG"),by.y=("V1"))
 
All_Data3$Per_Right <- All_Data3$Right / All_Data3$CT
All_Data3$Per_UpStream <- All_Data3$UpStream / All_Data3$CT
All_Data3$Per_Left <- All_Data3$Left / All_Data3$CT
All_Data3$Per_DownStream <- All_Data3$DownStream / All_Data3$CT
colnames(All_Data3)[1] <- "I_J"

#write.csv(All_Data3,file=("April_Centroid.csv"))

#################################################VERTICAL PROFILE##################################################
Vertical_Profile <- merge(GPS_File,All_Data3,by.x=("I_J"),by.y=("I_J"),all=TRUE)
Vertical_Profile_Headers <- c("I_J","Easting_m","Northing_m","Depth_m","Elev_m_1","Relative_Depth","u_cm_s","v_cm_s",
                              "w_cm_s","hmag_cm_s","mag_cm_s_","hdir_deg_","vdir_deg_","Cent_X.x",
                              "Cent_Y.x","UTM_X","UTM_Y","MEAN_depth_m","MAX_Depth_m","MIN_Depth_m",
                              "MAX_hmag_cm_s","MIN_hmag_cm_s",".0625MEAN_Mag",".0625MEAN_Dir",
                              ".1875MEAN_Mag",".1875MEAN_Dir",".3125MEAN_Mag",".3125MEAN_Dir",
                              ".4375MEAN_Mag",".4375MEAN_Dir",".5625MEAN_Mag",".5625MEAN_Dir",
                              ".6875MEAN_Mag",".6875MEAN_Dir",".8125MEAN_Mag",".8125MEAN_Dir",
                              ".9375MEAN_Mag",".9375MEAN_Dir","Per_Right","Per_UpStream",
                              "Per_Left","Per_DownStream","CT","MEAN_Mag","MEAN_Dir")

Vertical_Profile <- Vertical_Profile[Vertical_Profile_Headers]

Vertical_Profile$V_Bin <- ifelse(Vertical_Profile$Relative_Depth > 0 & Vertical_Profile$Relative_Depth <=.125 ,.0625
                                 ,ifelse(Vertical_Profile$Relative_Depth>.125 & Vertical_Profile$Relative_Depth <=.25,.1875,
                                  ifelse(Vertical_Profile$Relative_Depth>.25 & Vertical_Profile$Relative_Depth <=.375,.3125,
                                  ifelse(Vertical_Profile$Relative_Depth>.375 & Vertical_Profile$Relative_Depth <=.5,.4375,
                                  ifelse(Vertical_Profile$Relative_Depth>.5 & Vertical_Profile$Relative_Depth <=.625,.5625,
                                  ifelse(Vertical_Profile$Relative_Depth>.625 & Vertical_Profile$Relative_Depth <=.75,.6875,
                                  ifelse(Vertical_Profile$Relative_Depth>.75 & Vertical_Profile$Relative_Depth <=.875,.8125,
                                  ifelse(Vertical_Profile$Relative_Depth>.875 & Vertical_Profile$Relative_Depth <=1,.9375,
                                         NA))))))))
################################################Calculate flow parrallel to the mean flow direction##########################
Vertical_Profile$Parralel_to_Mean_Flow <- ((sqrt(Vertical_Profile$u_cm_s^2 + Vertical_Profile$v_cm_s^2))*cos(((pi/180)*
                                            Vertical_Profile$hdir_deg_)-((pi/180)*Vertical_Profile$MEAN_Dir)))

Vertical_Profile$BIN_ID <- paste(Vertical_Profile$I_J,Vertical_Profile$V_Bin)
Vertical_Profile_Mean <- aggregate(Vertical_Profile,by=list(Vertical_Profile$BIN_ID),FUN=mean)
Vertical_Profile_Mean$I_J <- gsub("\\s0.\\d\\d\\d\\d","",Vertical_Profile_Mean$Group.1)

#Direction_Sum <- ddply(Direction,"V1",summarize,Right=sum(Right),UpStream=sum(UpStream),Left=sum(Left),DownStream=
#                         sum(DownStream))  
#Depth_.0625mean <- aggregate(Depth_.0625, by=list(Depth_.0625$I_J), FUN=mean)
#All_Final$Flow_Dir <-  atan2(All_Final$V_n,All_Final$V_e)
#All_Final$FlowDS <- All_Final$DS_Dir*.0174532925
#All_Final$Down_Stream_Velocity <- ((sqrt(All_Final$V_e^2+All_Final$V_n^2))*cos((All_Final$Flow_Dir-(All_Final$FlowDS))))*-1



#Vertical_Profile <- rbind(Depth_.0625,setNames((Depth_.1875), names(Depth_.0625)),
#                          setNames((Depth_.3125), names(Depth_.0625)),
#                          setNames((Depth_.4375), names(Depth_.0625)),
#                          setNames((Depth_.5625), names(Depth_.0625)),
#                          setNames((Depth_.6875), names(Depth_.0625)),
#                          setNames((Depth_.8125), names(Depth_.0625)),
#                          setNames((Depth_.9375), names(Depth_.0625)))

#Vertical_Profile["MEAN_Mag"] <- sqrt((Vertical_Profile$u_cm_s.0625MEAN^2)+(Vertical_Profile$v_cm_s.0625MEAN^2))

Cell_ID <- unique(Vertical_Profile$I_J)

doPlot = function(Cell_ID) {
  dum <- Vertical_Profile[Vertical_Profile$I_J == Cell_ID,]
  ggobj = ggplot(dum,aes(x=Parralel_to_Mean_Flow,y=Relative_Depth))+
    
    geom_rect(data=dum,aes(xmax=Inf,xmin=-Inf,ymax=Inf,ymin=.125),fill="white",alpha=.2)+
    geom_rect(data=dum,aes(xmax=Inf,xmin=-Inf,ymax=.125,ymin=0),colour="light grey",alpha=.2)+
    geom_rect(data=dum,aes(xmax=Inf,xmin=-Inf,ymax=.25,ymin=.125),colour="white")+
    geom_rect(data=dum,aes(xmax=Inf,xmin=-Inf,ymax=.375,ymin=.25),colour="white")+
    geom_rect(data=dum,aes(xmax=Inf,xmin=-Inf,ymax=.5,ymin=.375),colour="white")+
    geom_rect(data=dum,aes(xmax=Inf,xmin=-Inf,ymax=.625,ymin=.5),colour="white")+
    geom_rect(data=dum,aes(xmax=Inf,xmin=-Inf,ymax=.75,ymin=.625),colour="white")+
    geom_rect(data=dum,aes(xmax=Inf,xmin=-Inf,ymax=.875,ymin=.75),colour="white")+
    geom_rect(data=dum,aes(xmax=Inf,xmin=-Inf,ymax=Inf,ymin=.875),fill="white")+
    geom_rect(data=dum,aes(xmax=Inf,xmin=-Inf,ymax=1,ymin=.875),colour="white")+
    geom_point(colour="blue")+
    #geom_text(data=dum,aes(x=hmag_cm_s,y=Relative_Depth*-1,label=hmag_cm_s),hjusst=0,vjust=0)+
    geom_point(data=subset(Vertical_Profile_Mean,Vertical_Profile_Mean$I_J == Cell_ID),aes(x=Parralel_to_Mean_Flow,y=V_Bin,size=10,
                                                                                           colour="red"))+
    xlab("Velocity Realative to Mean Flow Direction for the Grid Cell (cm/s)")+
    ylab("Realative Depth")+
    ggtitle(Cell_ID)+
    theme(legend.position="none")+
    scale_y_reverse()
    
  #geom_smooth(data=subset(Vertical_Profile_Mean,Vertical_Profile_Mean$I_J == Cell_ID)
  #           ,method = "lm", se=FALSE, color="black", formula = y ~ x)
  #geom_text(data=subset(Vertical_Profile,Vertical_Profile$Group.1 == Cell_ID)
  # ,aes(x=MEAN_Mag,y=V_Bin*-1,label=hmag_cm_s.0625MEAN),hjusst=0,vjust=0,colour="red")
  
  
  print(ggobj)
  ggsave(sprintf("%s_vertical.pdf", Cell_ID))
  
}
lapply(unique(GPS_File$I_J), doPlot)

Final_Data_Headers <- c("I_J","V_Bin","MEAN_depth_m","MAX_Depth_m","MIN_Depth_m","Elev_m_1","Relative_Depth",
                        "u_cm_s","v_cm_s","w_cm_s","vdir_deg_","Cent_X.x","Cent_Y.x","UTM_X","UTM_Y",
                        ".0625MEAN_Mag",".0625MEAN_Dir",".1875MEAN_Mag",".1875MEAN_Dir",".3125MEAN_Mag",
                        ".3125MEAN_Dir",".4375MEAN_Mag",".4375MEAN_Dir",".5625MEAN_Mag",".5625MEAN_Dir",
                        ".6875MEAN_Mag",".6875MEAN_Dir",".8125MEAN_Mag",".8125MEAN_Dir",".9375MEAN_Mag",
                        ".9375MEAN_Dir","MEAN_Mag","MEAN_Dir","Parralel_to_Mean_Flow","CT","Per_DownStream",
                        "Per_Left","Per_UpStream","Per_Right")
Final_Data <- Vertical_Profile_Mean[Final_Data_Headers]

write.csv(Final_Data,file="Final_Data.csv")
